// add columns grid layout (for developpement)
class guiCol extends Paged.Handler {
  constructor(chunker, polisher, caller) {
    super(chunker, polisher, caller);
  }

  afterRendered(pages) {
    let nbOfColumns = getComputedStyle(document.documentElement).getPropertyValue('--grid-col');
    let gap = getComputedStyle(document.documentElement).getPropertyValue('--grid-gap');


    let guidelines = false;
    // Show / Hide Guidelines by ctrl + b
    document.addEventListener('keydown', function(e){
      // e.preventDefault()
      let target = e.target;
      let margins = document.querySelectorAll('.pagedjs_page_content');
      let cols = document.querySelectorAll('.gui-column');
      if (e.ctrlKey && e.key == 'b') { 
        if(guidelines){
          console.log("Hide guidelines");
          guidelines = false;
          margins.forEach(function(el, i) {
            el.style.outline = "none";
          });
          cols.forEach(function(col, i) {
            col.style.outline = "none";
          }); 
        }
        else{
          console.log("Display guidelines");
          guidelines = true;
          margins.forEach(function(el, i) {
            el.style.outline = "1px solid magenta";
          });
          cols.forEach(function(col, i) {
            col.style.outline = "1px solid cyan";
          });
        }

        e.preventDefault();
      }
    });
    for(let i=0; i<pages.length; i++){
      let colWrapper = document.createElement("div");
      colWrapper.classList.add('col-wrapper');
      for(let a=0; a<nbOfColumns; a++){
        let col = document.createElement("div");
        col.classList.add('gui-column');
        let widthInPercent = 100 / nbOfColumns;
        col.style.width = "calc("+widthInPercent+"% - calc("+gap+"mm /2))";
        colWrapper.appendChild(col);
      }
      pages[i].area.appendChild(colWrapper);
    }
  }
}

Paged.registerHandlers(guiCol);